﻿// danny davis
// visualadvance.com

package 
{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.filters.*;

	public class Main extends MovieClip
	{
		private var dust:Dust;
		private var swayAmount:Number=0;

		private var bmpData:BitmapData;
		private var bmp:Bitmap;

		private var alphaRatio:Number= 400 / 16777215;

		public function Main ()
		{
			stage.addEventListener (MouseEvent.MOUSE_DOWN, backOn);
			stage.addEventListener (MouseEvent.MOUSE_UP, backOff);
			bmpData=new BitmapData(stage.stageWidth,stage.stageHeight,true,0x00000000);
			bmpData.draw (sourceClip);
			sourceClip.visible=false;
			
			// make the dust
			for (var i:uint=0; i < 250; i++)
			{
				dust=new Dust  ;
				dust.x=Math.random() * stage.stageWidth;
				dust.y=Math.random() * stage.stageHeight;
				dust.scaleAmount=.1 + Math.random() * .6;
				dust.scaleX=dust.scaleY=dust.scaleAmount;
				dust.startAlpha=.01 + Math.random() * .3;
				dust.particle.alpha=dust.startAlpha;
				dust.speed=.1 + Math.random() * .3;
				dust.rotateAmount=2 - Math.random() * 4;
				dust.rotation=Math.random() * 360;

				dust.startX=dust.x;
				dust.startAngle=Math.random() * 150;
				dust.amp=1 + Math.random() * 5;

				var blurAmount:Number=Math.floor(Math.random() * 3);
				var filter:BitmapFilter=new BlurFilter(blurAmount,blurAmount,BitmapFilterQuality.LOW);
				var myFilters:Array=new Array;
				myFilters.push (filter);
				dust.filters=myFilters;

				dust.addEventListener (Event.ENTER_FRAME,dustEnter);
				this.addChild (dust);
			}
		}
		private function backOn (evt:Event):void
		{
			back_mc.visible= false;
		}
		private function backOff (evt:Event):void
		{
			back_mc.visible = true;
		}
		private function dustEnter (evt:Event):void
		{
			evt.target.x=evt.target.startX + Math.cos(evt.target.startAngle) * evt.target.amp;
			evt.target.startAngle+= .05;

			evt.target.alpha=bmpData.getPixel(evt.target.x,evt.target.y) * alphaRatio / 100;;

			var randomNum:Number=Math.floor(Math.random() * 5);
			if (randomNum == 0)
			{
				evt.target.particle.alpha=evt.target.startAlpha + Math.random() * .1;
				evt.target.scaleX=evt.target.scaleY=evt.target.scaleAmount - Math.random() * .1;
			}
			
			evt.target.y+= evt.target.speed;
			evt.target.rotation+= 5;
			if (evt.target.y > stage.stageHeight)
			{
				evt.target.y=0;
			}
		}
	}
}